Drilldown with Zoom in JavaScript

Using ApexCharts with JavaScript

This Drilldown with Zoom example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Revenue',
      data: [
        { x: '2021', y: 480, drilldown: '2021' },
        { x: '2022', y: 530, drilldown: '2022' },
        { x: '2023', y: 610, drilldown: '2023' },
        { x: '2024', y: 705, drilldown: '2024' },
      ],
    },
  ],
  chart: {
    type: 'bar',
    height: 420,
    toolbar: {
      show: false,
    },
  },
  plotOptions: {
    bar: {
      distributed: true,
      columnWidth: '55%',
      borderRadius: 6,
      borderRadiusApplication: 'end',
    },
  },
  legend: {
    show: false,
  },
  dataLabels: {
    enabled: false,
  },
  colors: ['#1565C0', '#2E7D32', '#EF6C00', '#6A1B9A'],
  title: {
    text: 'Revenue by Year',
    align: 'left',
  },
  subtitle: {
    text: 'Click a year: its quarterly breakdown unfolds outward from the column you click. Use the breadcrumb to go back.',
    align: 'left',
  },
  yaxis: {
    title: {
      text: 'Revenue ($k)',
    },
  },
  drilldown: {
    enabled: true,
    // Anchor the drill transition at the clicked column: the child's bars unfold
    // outward from that column rather than the chart simply re-rendering.
    animation: {
      enabled: true,
      zoomFromPoint: true,
      speed: 260,
    },
    breadcrumb: {
      show: true,
      position: 'top-right',
      rootLabel: 'All Years',
      separator: ' / ',
    },
    series: [
      {
        id: '2021',
        name: '2021 by Quarter',
        data: [
          { x: 'Q1', y: 105 },
          { x: 'Q2', y: 118 },
          { x: 'Q3', y: 125 },
          { x: 'Q4', y: 132 },
        ],
      },
      {
        id: '2022',
        name: '2022 by Quarter',
        data: [
          { x: 'Q1', y: 121 },
          { x: 'Q2', y: 130 },
          { x: 'Q3', y: 138 },
          { x: 'Q4', y: 141 },
        ],
      },
      {
        id: '2023',
        name: '2023 by Quarter',
        data: [
          { x: 'Q1', y: 140 },
          { x: 'Q2', y: 152 },
          { x: 'Q3', y: 158 },
          { x: 'Q4', y: 160 },
        ],
      },
      {
        id: '2024',
        name: '2024 by Quarter',
        data: [
          { x: 'Q1', y: 165 },
          { x: 'Q2', y: 174 },
          { x: 'Q3', y: 182 },
          { x: 'Q4', y: 184 },
        ],
      },
    ],
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Drilldown with Zoom in Angular

Using ApexCharts with Angular

This Drilldown with Zoom example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Revenue',
              data: [
                { x: '2021', y: 480, drilldown: '2021' },
                { x: '2022', y: 530, drilldown: '2022' },
                { x: '2023', y: 610, drilldown: '2023' },
                { x: '2024', y: 705, drilldown: '2024' },
              ],
            },
          ],
          chart: {
            type: 'bar',
            height: 420,
            toolbar: {
              show: false,
            },
          },
          plotOptions: {
            bar: {
              distributed: true,
              columnWidth: '55%',
              borderRadius: 6,
              borderRadiusApplication: 'end',
            },
          },
          legend: {
            show: false,
          },
          dataLabels: {
            enabled: false,
          },
          colors: ['#1565C0', '#2E7D32', '#EF6C00', '#6A1B9A'],
          title: {
            text: 'Revenue by Year',
            align: 'left',
          },
          subtitle: {
            text: 'Click a year: its quarterly breakdown unfolds outward from the column you click. Use the breadcrumb to go back.',
            align: 'left',
          },
          yaxis: {
            title: {
              text: 'Revenue ($k)',
            },
          },
          drilldown: {
            enabled: true,
            // Anchor the drill transition at the clicked column: the child's bars unfold
            // outward from that column rather than the chart simply re-rendering.
            animation: {
              enabled: true,
              zoomFromPoint: true,
              speed: 260,
            },
            breadcrumb: {
              show: true,
              position: 'top-right',
              rootLabel: 'All Years',
              separator: ' / ',
            },
            series: [
              {
                id: '2021',
                name: '2021 by Quarter',
                data: [
                  { x: 'Q1', y: 105 },
                  { x: 'Q2', y: 118 },
                  { x: 'Q3', y: 125 },
                  { x: 'Q4', y: 132 },
                ],
              },
              {
                id: '2022',
                name: '2022 by Quarter',
                data: [
                  { x: 'Q1', y: 121 },
                  { x: 'Q2', y: 130 },
                  { x: 'Q3', y: 138 },
                  { x: 'Q4', y: 141 },
                ],
              },
              {
                id: '2023',
                name: '2023 by Quarter',
                data: [
                  { x: 'Q1', y: 140 },
                  { x: 'Q2', y: 152 },
                  { x: 'Q3', y: 158 },
                  { x: 'Q4', y: 160 },
                ],
              },
              {
                id: '2024',
                name: '2024 by Quarter',
                data: [
                  { x: 'Q1', y: 165 },
                  { x: 'Q2', y: 174 },
                  { x: 'Q3', y: 182 },
                  { x: 'Q4', y: 184 },
                ],
              },
            ],
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Drilldown with Zoom in Vue

Using ApexCharts with Vue

This Drilldown with Zoom example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="bar"
        height="420"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Revenue',
          data: [
            { x: '2021', y: 480, drilldown: '2021' },
            { x: '2022', y: 530, drilldown: '2022' },
            { x: '2023', y: 610, drilldown: '2023' },
            { x: '2024', y: 705, drilldown: '2024' },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'bar',
          height: 420,
          toolbar: {
            show: false,
          },
        },
        plotOptions: {
          bar: {
            distributed: true,
            columnWidth: '55%',
            borderRadius: 6,
            borderRadiusApplication: 'end',
          },
        },
        legend: {
          show: false,
        },
        dataLabels: {
          enabled: false,
        },
        colors: ['#1565C0', '#2E7D32', '#EF6C00', '#6A1B9A'],
        title: {
          text: 'Revenue by Year',
          align: 'left',
        },
        subtitle: {
          text: 'Click a year: its quarterly breakdown unfolds outward from the column you click. Use the breadcrumb to go back.',
          align: 'left',
        },
        yaxis: {
          title: {
            text: 'Revenue ($k)',
          },
        },
        drilldown: {
          enabled: true,
          // Anchor the drill transition at the clicked column: the child's bars unfold
          // outward from that column rather than the chart simply re-rendering.
          animation: {
            enabled: true,
            zoomFromPoint: true,
            speed: 260,
          },
          breadcrumb: {
            show: true,
            position: 'top-right',
            rootLabel: 'All Years',
            separator: ' / ',
          },
          series: [
            {
              id: '2021',
              name: '2021 by Quarter',
              data: [
                { x: 'Q1', y: 105 },
                { x: 'Q2', y: 118 },
                { x: 'Q3', y: 125 },
                { x: 'Q4', y: 132 },
              ],
            },
            {
              id: '2022',
              name: '2022 by Quarter',
              data: [
                { x: 'Q1', y: 121 },
                { x: 'Q2', y: 130 },
                { x: 'Q3', y: 138 },
                { x: 'Q4', y: 141 },
              ],
            },
            {
              id: '2023',
              name: '2023 by Quarter',
              data: [
                { x: 'Q1', y: 140 },
                { x: 'Q2', y: 152 },
                { x: 'Q3', y: 158 },
                { x: 'Q4', y: 160 },
              ],
            },
            {
              id: '2024',
              name: '2024 by Quarter',
              data: [
                { x: 'Q1', y: 165 },
                { x: 'Q2', y: 174 },
                { x: 'Q3', y: 182 },
                { x: 'Q4', y: 184 },
              ],
            },
          ],
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Drilldown with Zoom in React

Using ApexCharts with React

This Drilldown with Zoom example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Revenue',
        data: [
          { x: '2021', y: 480, drilldown: '2021' },
          { x: '2022', y: 530, drilldown: '2022' },
          { x: '2023', y: 610, drilldown: '2023' },
          { x: '2024', y: 705, drilldown: '2024' },
        ],
      },
    ],
    options: {
      chart: {
        type: 'bar',
        height: 420,
        toolbar: {
          show: false,
        },
      },
      plotOptions: {
        bar: {
          distributed: true,
          columnWidth: '55%',
          borderRadius: 6,
          borderRadiusApplication: 'end',
        },
      },
      legend: {
        show: false,
      },
      dataLabels: {
        enabled: false,
      },
      colors: ['#1565C0', '#2E7D32', '#EF6C00', '#6A1B9A'],
      title: {
        text: 'Revenue by Year',
        align: 'left',
      },
      subtitle: {
        text: 'Click a year: its quarterly breakdown unfolds outward from the column you click. Use the breadcrumb to go back.',
        align: 'left',
      },
      yaxis: {
        title: {
          text: 'Revenue ($k)',
        },
      },
      drilldown: {
        enabled: true,
        // Anchor the drill transition at the clicked column: the child's bars unfold
        // outward from that column rather than the chart simply re-rendering.
        animation: {
          enabled: true,
          zoomFromPoint: true,
          speed: 260,
        },
        breadcrumb: {
          show: true,
          position: 'top-right',
          rootLabel: 'All Years',
          separator: ' / ',
        },
        series: [
          {
            id: '2021',
            name: '2021 by Quarter',
            data: [
              { x: 'Q1', y: 105 },
              { x: 'Q2', y: 118 },
              { x: 'Q3', y: 125 },
              { x: 'Q4', y: 132 },
            ],
          },
          {
            id: '2022',
            name: '2022 by Quarter',
            data: [
              { x: 'Q1', y: 121 },
              { x: 'Q2', y: 130 },
              { x: 'Q3', y: 138 },
              { x: 'Q4', y: 141 },
            ],
          },
          {
            id: '2023',
            name: '2023 by Quarter',
            data: [
              { x: 'Q1', y: 140 },
              { x: 'Q2', y: 152 },
              { x: 'Q3', y: 158 },
              { x: 'Q4', y: 160 },
            ],
          },
          {
            id: '2024',
            name: '2024 by Quarter',
            data: [
              { x: 'Q1', y: 165 },
              { x: 'Q2', y: 174 },
              { x: 'Q3', y: 182 },
              { x: 'Q4', y: 184 },
            ],
          },
        ],
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="bar"
          height={420}
        />
      </div>
    </div>
  )
}

export default ApexChart